.386
.model flat,stdcall
option casemap:none

include \masm32\include\windows.inc 
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\comctl32.inc
includelib \masm32\lib\comctl32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\shell32.lib
include \masm32\include\shell32.inc


MainWindow 		proto
ViewFile		proto		:DWORD, :DWORD
RunFile			proto		:BYTE
WindowProc      proto       :DWORD,:DWORD,:DWORD,:DWORD

.data
classname		db		"ListViewWinClass",0
windowname		db		"FileBrowser",0
ListViewName	db		"SysListView32",0
FileName		db		"*.*",0
Header		db		"File name",0
DefaultPath		db		"C:\",0
EditName		db		"edit",0
ButClass		db		"button",0
ButName		db		"Gooo!",0

.data?
hInstance		HINSTANCE		?
hList			dd	?
hEdit			dd	?
hButton		dd	?
buffer		db	256 dup (?)
writepath         db    256 dup (?)

.code
start:

invoke			GetModuleHandle, NULL
mov				hInstance, eax
invoke			InitCommonControls
invoke			MainWindow
invoke			ExitProcess, 0

MainWindow proc

LOCAL			message:MSG
LOCAL			hWindow:HWND
LOCAL			WC:WNDCLASSEX

mov				WC.cbSize,SIZEOF WNDCLASSEX
mov				WC.style, NULL
mov				WC.lpfnWndProc, OFFSET WindowProc
mov				WC.cbClsExtra, NULL
mov				WC.cbWndExtra, NULL
push			hInstance
pop				WC.hInstance
invoke			LoadIcon, NULL, IDI_APPLICATION
mov				WC.hIcon, eax
mov				WC.hIconSm, eax
invoke			LoadCursor, NULL, IDC_ARROW
mov				WC.hCursor, eax
mov 			WC.hbrBackground, COLOR_WINDOW+1
mov				WC.lpszMenuName, NULL
mov				WC.lpszClassName, OFFSET classname
invoke			RegisterClassEx, addr WC
invoke			CreateWindowEx, NULL, addr classname, addr windowname,\
WS_OVERLAPPEDWINDOW,	CW_USEDEFAULT, CW_USEDEFAULT,\
CW_USEDEFAULT,  CW_USEDEFAULT, NULL, \
NULL, hInstance, NULL
mov				hWindow, eax
invoke			ShowWindow, hWindow, SW_SHOWDEFAULT

.While TRUE
	invoke		GetMessage, addr message, NULL, 0, 0
	.BREAK .IF (!eax)
	invoke		TranslateMessage, addr message
	invoke		DispatchMessage, addr message
.endw

ret
MainWindow endp

WindowProc		proc hWnd:HWND, WinMsg:UINT, wParam:WPARAM,	lParam:LPARAM
    .if WinMsg==WM_DESTROY 
        invoke PostQuitMessage, NULL
	  ret

    .elseif		WinMsg==WM_CREATE
        invoke CreateWindowEx,0,addr EditName,0,\
        WS_DLGFRAME+WS_CHILD+ES_AUTOHSCROLL,
	  0,0,710,25,\
        hWnd,0,hInstance,0
    mov			hEdit, eax
    invoke		ShowWindow,hEdit,SW_SHOWDEFAULT
    invoke		SendMessage,hEdit,WM_SETTEXT,0,Addr writepath
    invoke		SendMessage,hEdit,EM_SETSEL,0,-1
    invoke		CreateWindowEx,0 , addr ButClass, addr ButName, \
			WS_CHILD+BS_DEFPUSHBUTTON+BS_TEXT+BS_VCENTER, \
			710,0,50,25, hWnd, 0, hInstance,0
    mov			hButton, eax
    invoke		ShowWindow,hButton,SW_SHOW
    invoke		CreateWindowEx, NULL, addr ListViewName, NULL,\
                WS_CHILD+LVS_REPORT+LVS_ALIGNLEFT+LVS_SORTASCENDING,\
                CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,\
                CW_USEDEFAULT, hWnd, NULL, hInstance, NULL
    mov			hList, eax
    invoke		ShowWindow, hList, SW_SHOW
    call		InsertColumn
    invoke		SetCurrentDirectory, addr DefaultPath
    call		ShowAll

    .ElseIf		WinMsg==WM_COMMAND
			mov eax,wParam
			shr eax,16
			.IF eax==BN_CLICKED
				mov			eax,lParam
				.If			eax==hButton
							invoke RunFile,1
				.endif
			.endif
    .ElseIf		WinMsg==WM_SIZE
        mov		eax,lParam
        mov 	edx,eax
        and		eax,0FFFFH
        shr		edx,16
        push	eax
        invoke	MoveWindow,hList, 0, 0, eax,edx,TRUE
        pop		eax
        sub		eax,50
        push	eax
        Invoke	MoveWindow,hEdit,0,0,eax,25,TRUE
        pop		eax
        invoke	MoveWindow,hButton,eax,0,50,25,TRUE
	
    .ElseIF		WinMsg==WM_NOTIFY
        mov edi,lParam
        assume	edi:ptr NMHDR
        mov		eax,[edi].hwndFrom
        .if		eax==hList
			.if [edi].code==NM_DBLCLK
				Invoke RunFile,0
			.ElseIf [edi].code==NM_RETURN
				Invoke RunFile,0
			.endif
        .endif
        assume edi:nothing
	
    .else
        invoke	DefWindowProc, hWnd, WinMsg, wParam, lParam
        ret
    .endif
        xor	eax,eax
    ret

WindowProc endp
 
InsertColumn proc
    LOCAL		lvc:LV_COLUMN

    mov			lvc.imask,LVCF_FMT+LVCF_WIDTH+LVCF_TEXT
    mov			lvc.fmt,LVCFMT_LEFT
    mov			lvc.lx,100
    mov			lvc.pszText, OFFSET Header
    invoke		SendMessage, hList, LVM_INSERTCOLUMN, 0, addr lvc	

 	ret

InsertColumn endp
 
 
 ShowAll proc uses edi WinFind_:DWORD 
    LOCAL		WinFind:WIN32_FIND_DATA
    LOCAL		FHandle:DWORD
    
    invoke 	FindFirstFile, addr FileName, addr WinFind
    .if		eax!=INVALID_HANDLE_VALUE
 			mov FHandle, eax
 			xor edi, edi
 			.while eax!=0
 				invoke ViewFile, edi, addr WinFind
 				inc edi
 				invoke FindNextFile, FHandle, addr WinFind
 			.endw
 			invoke FindClose, FHandle
    .endif
 	
    ret

ShowAll endp
 
ViewFile proc uses edi eilute:DWORD, WinFind:DWORD
 
     LOCAL		LVI:LV_ITEM
 
    mov		edi, WinFind
    assume		edi:ptr WIN32_FIND_DATA
    mov		LVI.imask,LVIF_TEXT
    push		eilute
    pop		LVI.iItem
    mov		LVI.iSubItem, 0
    lea		eax,[edi].cFileName
    mov		LVI.pszText,eax
    push		eilute
    pop		LVI.lParam
    invoke		SendMessage, hList, LVM_INSERTITEM, 0, addr LVI
    assume		edi:nothing
 	
    ret

ViewFile endp			



RunFile		proc	EorL:BYTE

    LOCAL		lvi:LV_ITEM

    .If 		EorL==1
        invoke	SendMessage,hEdit,WM_GETTEXT,256,addr buffer
    .Else
        invoke 	SendMessage,hList,LVM_GETNEXTITEM, -1, LVNI_FOCUSED
        mov		lvi.iItem,eax
        mov		lvi.imask,LVIF_TEXT
        lea		eax,buffer
        mov		lvi.pszText,eax
        mov		lvi.iSubItem,0
        mov		lvi.cchTextMax,256
        invoke	SendMessage, hList, LVM_GETITEM, 0, addr lvi				
    .EndIf
        invoke		GetFileAttributes, addr buffer
        and			eax,10h		;FILE_ATTRIBUTE_DIRECTORY=10h, LOL...
        .If		eax!=0
            invoke SendMessage, hList, LVM_DELETEALLITEMS, 0, 0
            invoke SetCurrentDirectory, addr buffer
		;call FillList
        .else
		invoke ShellExecuteA,0,0,addr buffer,0,0,SW_SHOWDEFAULT
        .endif
	
	ret
RunFile endp

end start